C $DIR CONFIG INFORMATION
C $DIR PART RIEMANN
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
      SUBROUTINE RIEMANN
     *      (GAMMA,NC,E,E1,R1,P1,U1,R2,P2,U2,CR,CP,CU,CS)
C****    
C       :
C   1) K1  -   1
C   2) NC  -   
C   3) E   - " " ( "" ,  =)
C   4) E1  -    
C  ,    
C    / ..
C   5) R1 -  
C   6) P1 -  
C   7) U1 -  
C   9) P2 -  
C  10) R2 -  
C  11) U2 -  
C  :
C  13) CR -     
C  14) CP -     
C  15) CU -     
C  17) CS -     
C>     
      IMPLICIT NONE
C>  
C   
      INTEGER NC
C   1
      REAL K1,  GAMMA
C " "
      REAL     E
C    
      REAL     E1
C  
      REAL R1
C  
      REAL P1
C  
      REAL U1
C  
      REAL R2
C  
      REAL P2
C  
      REAL U2
C     
      REAL CR
C     
      REAL CP
C     
      REAL CU
C     
      REAL CS
c      real velmax
C   
      INTEGER N1
      INTEGER N2
      INTEGER NCN
      REAL M1
      REAL M2
      REAL A2
      REAL A3
      REAL A4
      REAL B2
      REAL B3
      REAL B4
      REAL C1
      REAL C2
      REAL C3
      REAL C4
      REAL CP1
      REAL WL
      REAL WR
      REAL K2
      REAL K3
      REAL K4
      REAL K5
      REAL K6
      REAL K7
C  ""    ()
      K1 = GAMMA -1.0
      K2=K1+1
      K3=2./K1
      K4=(K2+1)/K1
      K5=0.5*K1/K2
      K6=1-K5
      K7=K5+1
c----|
      NCN=0
      M1=SQRT(K2*P1/R1)
      M2=SQRT(K2*P2/R2)
      CU=U1-U2
      CR=R1*M1
      CS=R2*M2
      CP1=(P1*CS+P2*CR+CU*CR*CS)/(CR+CS)
    1 CONTINUE
      IF( CP1.LT.E) CP1=E
      NCN=NCN+1
      C1=CP1/P1
      C2=CP1/P2
      IF( NCN.GT.NC) THEN
      CP=CP1
      GOTO 2
      ENDIF
      IF( C1.LT.0.99) THEN
      N1=1
      WL=U1-M1
      A4=C1**K5
      A2=K5*CR*(1.-C1)/(1.-A4)
      A3=M1*A4/(CP1*K2)
      ELSE
      C3=K4*C1+1.
      A4=M1*SQRT(K5*C3)
      A2=R1*A4
      N1=2
      WL=U1-A4
      A3=CR/A2*CR/A2*(K6*C1+K7)/A2*0.5
      ENDIF
      IF( C2.LT.0.99) THEN
      N2=1
      WR=U2+M2
      B4=C2**K5
      B2=K5*CS*(1.-C2)/(1.-B4)
      B3=M2*B4/(CP1*K2)
      ELSE
      C4=K4*C2+1.
      B4=M2*SQRT(K5*C4)
      B2=R2*B4
      N2=2
      WR=U2+B4
      B3=CS/B2*CS/B2*(K6*C2+K7)/B2*0.5
      ENDIF
      CP=CP1-((CP1-P1)/A2+(CP1-P2)/B2-CU)/(A3+B3)
      IF( ABS(CP-CP1)/CP1.GT.E1) THEN
      CP1=CP
      GOTO 1
      ENDIF
      IF( CP.LT.E)CP=E
    2 CONTINUE
      IF( WL.GT.0.) THEN
      CP=P1
      CR=R1
      CU=U1
      GOTO 3
      ENDIF
      CU=(A2*U1+B2*U2+P1-P2)/(A2+B2)
      IF( CU.GT.0.)THEN
      IF( N1 .EQ. 1) THEN
      WL=M1*A4
      IF( (CU-WL).GT.0.) THEN
      CU=(U1+M1*K3)/K4
      CR=R1*(CU/M1)**K3
      CP=CR*CU*CU/K2
      GOTO 3
      ENDIF
      CR=CP*K2/(WL*WL)
      GOTO 3
      ENDIF
      CR=R1*C3/(C1+K4)
      GOTO 3
      ENDIF
      IF( WR.LT.0.) THEN
      CR=R2
      CP=P2
      CU=U2
      GOTO 3
      ENDIF
      IF( N2 .EQ. 1) THEN
      WR=M2*B4
      IF( (CU+WR).LT.0.) THEN
      CU=(U2-M2*K3)/K4
      CR=R1*(-CU*M2)**K3
      CP=CR*CU*CU/K2
      GOTO 3
      ENDIF
      CR=CP*K2/(WR*WR)
      GOTO 3
      ENDIF
      CR=R2*C4/(C2+K4)
    3 CONTINUE
      CS=CP / (CR * K1) + CU*CU*0.5
c      if ( velmax .lt. abs(wl) ) velmax= abs(wl)
c      if ( velmax .lt. abs(wr) ) velmax= abs(wr)
      RETURN
      END
